import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Sigman.FormationAssist2.Random";

function LeftShiftWindows()
    if senderID > 0 then
       if FASubWindow[senderID]:GetTop() > 30 then
       	  WinH = 0;
       end
    end
    for mw = senderID+1, table.maxn(FASubWindow) do
	WinY = FASubWindow[mw]:GetTop();
	if WinY > 30 then
	   WinX = FASubWindow[mw]:GetLeft();
	   WinY = WinY - WinH - 10;
 	else
	   WinX = FASubWindow[mw]:GetLeft() - 210;
	   WinH = FASubWindow[mw]:GetHeight();
	end
    	FASubWindow[mw]:SetPosition(WinX,WinY);
    end
end

function RightShiftWindows()
    for mw = senderID+1, table.maxn(FASubWindow) do
	WinX = FASubWindow[mw]:GetLeft() + 210;
	WinY = FASubWindow[mw]:GetTop()
	if WinX+420 > Turbine.UI.Display.GetWidth() then
	   WinX = WinX - 210;
	   WinY = FASubWindow[mw-1]:GetTop() + FASubWindow[mw-1]:GetHeight() + 10;
 	end
    	FASubWindow[mw]:SetPosition(WinX,WinY);
    end
end


Squad_menu = Turbine.UI.ContextMenu();
Squad_menu_items = Squad_menu:GetItems();

Squad_menu_item = Turbine.UI.MenuItem("Show");
Squad_menu_item.Click = function(sender, args)
	if FAMainWindow == nil then
	   	SquadBuild();
	else
		FAMainWindow:SetVisible(true);
		for i = 1 , table.maxn(FASubWindow) do
 		    FASubWindow[i]:SetVisible(true);
		end
	end
end
Squad_menu_items:Add(Squad_menu_item);

Squad_menu_item = Turbine.UI.MenuItem("Hide");
Squad_menu_item.Click = function(sender, args)
	if FAMainWindow ~= nil then
		FAMainWindow:SetVisible(false);
		for i = 1 , table.maxn(FASubWindow) do
 		    FASubWindow[i]:SetVisible(false);
		end
	end
end

Squad_menu_items:Add(Squad_menu_item);

Squad_menu_item = Turbine.UI.MenuItem("Reset");
Squad_menu_item.Click = function(sender, args)
	   	SquadBuild();
end

Squad_menu_items:Add(Squad_menu_item);

Squad_menu_item = Turbine.UI.MenuItem("Load");
Squad_menu_item.Click = function(sender, args)
	   	SquadBuild();
		if settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][1] == nil then
			FAMainWindow.squadname:SetText("Squad 1");
		else
			FAMainWindow.squadname:SetText(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][1]);
		end
	       	SquadCount = table.maxn(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ]);

		for i = 2, SquadCount do
		    if i > 2 then
		       AddSquad();
		    end
		    if settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][i] == nil then
			FASubWindow[i-1].squadname:SetText("Squad "..i);
		    else
			FASubWindow[i-1].squadname:SetText(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][i]);
		    end
		    SquadMemberC = table.maxn(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i][1]);
		    FASubWindow[i-1]:SetHeight(150 + 23 * SquadMemberC);
		    FASubWindow[i-1].listbox:SetHeight( 20 + 20 * SquadMemberC );
		    for j = 1, SquadMemberC do
            	    	listItem = Turbine.UI.Control();
            		listItem:SetSize( 370, 20 );
 	    		listItem.Qty=Turbine.UI.Label();
	    		listItem.Qty:SetParent(listItem);
	    		listItem.Qty:SetSize(115,20);
	    		listItem.Qty:SetPosition(25,0);
	    		listItem.Qty:SetTop(1);
	    		listItem.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			SquadMember = settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i][1][j];
	    		listItem.Qty:SetText(SquadMember);
			listItem.Com = Turbine.UI.TextBox();
	    		listItem.Com:SetMultiline(false);
      	   		listItem.Com:SetParent( listItem );
     	    		listItem.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    		listItem.Com:SetSize( 230, 20 );
	    		listItem.Com:SetPosition(140,0);
	    		listItem.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			SquadCom = settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i][2][j];
	    		listItem.Com:SetText(SquadCom);
	    		listItem.Img=Turbine.UI.Label();
	    		listItem.Img:SetParent(listItem);
	    		listItem.Img:SetSize(20,20);
	    		listItem.Img:SetPosition(0,0);
	    		listItem.Img:SetTop(1);
			sameindex = 0;
			for ii = 1 , FAMainWindow.listbox:GetItemCount() do
			    RaidItem = FAMainWindow.listbox:GetItem(ii);
			    if RaidItem.Qty:GetText() == SquadMember then
	    		       listItem.Img:SetBackground(RaidItem.Img:GetBackground());
			       sameindex = ii;
			       break;
			    end
			end
			if listItem.Img:GetBackground() == nil then
	    		    listItem.Qty:SetBackColor( Turbine.UI.Color( 1, 0, 0 ) );
			end
	    		FASubWindow[i-1].listbox:InsertItem( j, listItem );
			if listItem.Img:GetBackground() ~= nil then
	    	   	       FAMainWindow.listbox:RemoveItemAt(sameindex);
		   	       FAMainWindow.listbox:SetHeight( FAMainWindow.listbox:GetHeight() - 20 );
	    	   	       FAMainWindow:SetHeight(FAMainWindow:GetHeight() - 23);
			end
		    end
		end
		   for i = 1, table.maxn(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][1]) do
			SquadMember = settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][1][i];
			SquadCom = settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][2][i];
			for ii = 1 , FAMainWindow.listbox:GetItemCount() do
			    RaidItem = FAMainWindow.listbox:GetItem(ii);
			    if RaidItem.Qty:GetText() == SquadMember then
	    		    RaidItem.Com:SetText(SquadCom);
					sameindex = ii;
					break;
			    end
			end
			FAMainWindow.listbox:SetItem( sameindex, RaidItem );
		   end
end

Squad_menu_items:Add(Squad_menu_item);

Squad_menu_item = Turbine.UI.MenuItem("Load Table");
Squad_menu_item.Click = function(sender, args)
		if settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][1] == nil then
			FAMainWindow.squadname:SetText("Squad 1");
		else
			FAMainWindow.squadname:SetText(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][1]);
		end
	       	SquadCount = table.maxn(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ]);

		for i = 2, SquadCount do
		    if i > table.maxn(FASubWindow)+1 then
		       AddSquad();
		    end
		    if settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][i] == nil then
			FASubWindow[i-1].squadname:SetText("Squad "..i);
		    else
			FASubWindow[i-1].squadname:SetText(settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][i]);
		    end
		end
end

Squad_menu_items:Add(Squad_menu_item);


Squad_menu_item = Turbine.UI.MenuItem("Random");
Squad_menu_item.Click = function(sender, args)
	   	SquadRandom();
end

Squad_menu_items:Add(Squad_menu_item);


function MakeSquad(sender, args)
	 if ( args.Button == Turbine.UI.MouseButton.Left ) then
	    Squad_menu:ShowMenu();
	 end
end


function SquadBuild()

local LABEL_WIDTH = 150;
local ROW_HEIGHT  = 20;
local ROW_SPACING = 3;
local BORDER_MARGIN = 5;
local MARGIN_TOP = 30;
local MARGIN_BOTTOM = 30;
MyChar = Turbine.Gameplay.LocalPlayer.GetInstance();

FormationAssistWidth = LABEL_WIDTH + 2 * ( BORDER_MARGIN + ROW_HEIGHT + ROW_SPACING );
FormationAssistHeight = 2 * BORDER_MARGIN + MARGIN_TOP + MARGIN_BOTTOM + ( ROW_HEIGHT + ROW_SPACING ) * 12 ;
FASubHeight = 2 * BORDER_MARGIN + MARGIN_TOP + MARGIN_BOTTOM + ( ROW_HEIGHT + ROW_SPACING ) ;

FAMainWindow = Turbine.UI.Window();
FAMainWindow:SetPosition(130,30);
FAMainWindow:SetSize(210,150);
FAMainWindow:SetText("Master");

FAMainWindow:SetVisible(true);
FAMainlock = Turbine.UI.Window();
FAMainlock:SetSize(20,20);
FAMainlock:SetParent( FAMainWindow );
FAMainlock:SetPosition(185,70);
FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/unlock.tga");
FAMainlock:SetVisible(true);
FAMainlock.lock = false;

FAMainlock.MouseClick=function(sender,args)
	if FAMainlock.lock then
	   FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/unlock.tga");
	   FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND_r.tga");
	   FAMainlock.lock = false;
	   FAMainslt2:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, ""));
	else
	   FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/lock.tga");
	   FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND.tga");
	   FAMainlock.lock = true;
	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = {};
	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0] = {};
	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = {};
	   for i = 1, 2 do
	       settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][i] = {};
	   end

	   tempString = tempCHANNEL .. " <rgb=#FF00FF>["..settings.SubMAP[FAmain.window.map.idx][ FAmain.window.Sub.idx ].."]</rgb>\n <rgb=#FFFF00>"..FAMainWindow.squadname:GetText().."</rgb> <rgb=#00FFFF>";
	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][1] = FAMainWindow.squadname:GetText();

	   for j = 1 , FAMainWindow.listbox:GetItemCount() do
	       SquadItem = FAMainWindow.listbox:GetItem(j);
	       SquadMember = SquadItem.Qty:GetText();
	       SquadCom = SquadItem.Com:GetText();
	       settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][1][j] = SquadMember;
	       settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1][2][j] = SquadCom;
	       if SquadCom ~= "" then
	       	  SquadCom = "(" .. SquadCom .. ")";
	       end
	       tempString = tempString .. SquadMember .. SquadCom .. ", ";
	   end
	   tempString = tempString .."</rgb>\n";
	   for i = 1 , table.maxn(FASubWindow) do
	       settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i+1] = {};
	       for j = 1, 2 do
	       	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i+1][j] = {};
	       end

	       settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][i+1] = FASubWindow[i].squadname:GetText();
	       if FASubWindow[i].listbox:GetItemCount() ~= 0 then
	       	  tempString = tempString .. " <rgb=#FFFF00>"..FASubWindow[i].squadname:GetText().."</rgb> <rgb=#00FFFF>";
	       	  for j = 1 , FASubWindow[i].listbox:GetItemCount() do
	       	      SquadItem = FASubWindow[i].listbox:GetItem(j);
	       	      SquadMember = SquadItem.Qty:GetText();
	       	      SquadCom = SquadItem.Com:GetText();
	       	      settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i+1][1][j] = SquadMember;
	       	      settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][i+1][2][j] = SquadCom;
	       	      if SquadCom ~= "" then
	       	      	 SquadCom = "(" .. SquadCom .. ")";
	       	      end
	       	      tempString = tempString .. SquadMember .. SquadCom .. ", ";
	       	  end
	       	  tempString = tempString .."</rgb>\n";
	       end
	   end
	   FAMainslt2:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, tempString));
	   FAmain.btn5.slt:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, tempString));
	   settings.Squad[FAmain.window.map.idx][ FAmain.window.Sub.idx ][0][0] = tempString;
	end

end


FAMainWindow.squadname = Turbine.UI.Lotro.TextBox();
FAMainWindow.squadname:SetParent( FAMainWindow );
FAMainWindow.squadname:SetBackColor( Turbine.UI.Color( 0, 0, 0.5 ) );
FAMainWindow.squadname:SetPosition( 10, 40 );
FAMainWindow.squadname:SetFont(Turbine.UI.Lotro.Font.Verdana16);
FAMainWindow.squadname:SetText("Squad 1");
FAMainWindow.squadname:SetSize( 190, 20 );


FAMainslt2 = Turbine.UI.Lotro.Quickslot();
FAMainslt2:SetParent(FAMainWindow);
FAMainslt2:SetSize(60,20);
FAMainslt2:SetPosition(120,70);
FAMainslt2:SetZOrder(1);
FAMainslt2:SetVisible(true);
FAMainbtn2 = Turbine.UI.Control();
FAMainbtn2:SetSize(FAMainslt2:GetSize());
FAMainbtn2:SetParent(FAMainWindow);
FAMainbtn2:SetPosition(FAMainslt2:GetLeft(),FAMainslt2:GetTop());
FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND_r.tga");
FAMainbtn2:SetMouseVisible(false);
FAMainbtn2:SetZOrder(10000);

FAMainslt2:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, ""));

FAMainWindow.listbox = Turbine.UI.ListBox();
FAMainWindow.listbox:SetParent( FAMainWindow );
FAMainWindow.listbox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
FAMainWindow.listbox:SetPosition( 30, 100 );
FAMainWindow.listbox:SetSize( 370, 20 );
FAMainWindow.listbox:SetAllowDrop( true );
FAMainWindow.listbox:SetMouseVisible(true);

Myparty=MyChar:GetParty();
if Myparty~=nil then
   if Myparty:GetMemberCount() > 6 then
	tempCHANNEL = "/ra";
   else
	tempCHANNEL = "/f";
   end

   for i = 1, Myparty:GetMemberCount() do
	FAMainWindow:SetHeight(FAMainWindow:GetHeight() + ROW_HEIGHT + ROW_SPACING);
      	FAMainWindow.listbox:SetHeight(FAMainWindow.listbox:GetHeight() + ROW_HEIGHT );
	Myparty.Member = Myparty:GetMember(i);

        local listItem = Turbine.UI.Control();
        listItem:SetSize( 370, 20 );
 	listItem:SetMouseVisible(true);
		listItem.Qty=Turbine.UI.Label();
		listItem.Qty:SetParent(listItem);
		listItem.Qty:SetSize(115,20);
		listItem.Qty:SetPosition(25,0);
		listItem.Qty:SetTop(1);
		listItem.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		listItem.Qty:SetText(Myparty.Member:GetName());
		listItem.Com = Turbine.UI.TextBox();
	    	listItem.Com:SetMultiline(false);
      	   	listItem.Com:SetParent( listItem );
     	    	listItem.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    	listItem.Com:SetSize( 230, 20 );
	    	listItem.Com:SetPosition(140,0);
	    	listItem.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		listItem.Com:SetText("");
		listItem.Img=Turbine.UI.Label();
		listItem.Img:SetParent(listItem);
		listItem.Img:SetSize(20,20);
		listItem.Img:SetPosition(0,0);
		listItem.Img:SetTop(1);
		listItem.Img:SetBackground("Sigman/FormationAssist2/Resources/" .. Myparty.Member:GetClass() .. ".tga");
        FAMainWindow.listbox:AddItem( listItem );
   end
else
   tempCHANNEL = "/tell ".. MyChar:GetName();

   Myparty={};
   Myparty.Member = {};
   for i = 1, 12 do
	FAMainWindow:SetHeight(FAMainWindow:GetHeight() + ROW_HEIGHT + ROW_SPACING);
      	FAMainWindow.listbox:SetHeight(FAMainWindow.listbox:GetHeight() + ROW_HEIGHT );

        local listItem = Turbine.UI.Control();
        listItem:SetSize( 370, 20 );
 	listItem:SetMouseVisible(true);
		listItem.Qty=Turbine.UI.Label();
		listItem.Qty:SetParent(listItem);
		listItem.Qty:SetSize(115,20);
		listItem.Qty:SetPosition(25,0);
		listItem.Qty:SetTop(1);
		listItem.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		listItem.Qty:SetText("Myparty"..i);
		listItem.Com = Turbine.UI.TextBox();
	    	listItem.Com:SetMultiline(false);
      	   	listItem.Com:SetParent( listItem );
     	    	listItem.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    	listItem.Com:SetSize( 230, 20 );
	    	listItem.Com:SetPosition(140,0);
	    	listItem.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		listItem.Com:SetText("");
		listItem.Img=Turbine.UI.Label();
		listItem.Img:SetParent(listItem);
		listItem.Img:SetSize(20,20);
		listItem.Img:SetPosition(0,0);
		listItem.Img:SetTop(1);
        FAMainWindow.listbox:AddItem( listItem );
   end



end


itemselect = false;
selectitem = Turbine.UI.Label();

listbox2MouseDown=function(sender,args)
	if itemselect then
	    if selectitem.Img:GetBackground() ~= nil then
	        sender:GetParent():SetHeight(sender:GetParent():GetHeight() + ROW_HEIGHT + ROW_SPACING);
      	    	sender:SetHeight(sender:GetHeight() + ROW_HEIGHT );
            	local listItem = Turbine.UI.Control();
            	listItem:SetSize( 370, 20 );
 	    	listItem.Qty=Turbine.UI.Label();
	    	listItem.Qty:SetParent(listItem);
	    	listItem.Qty:SetSize(115,20);
	    	listItem.Qty:SetPosition(25,0);
	    	listItem.Qty:SetTop(1);
	    	listItem.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem.Qty:SetText(selectitem.Qty:GetText());
	    	listItem.Com = Turbine.UI.TextBox();
	    	listItem.Com:SetMultiline(false);
      	    	listItem.Com:SetParent( listItem );
     	    	listItem.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    	listItem.Com:SetSize( 230, 20 );
	    	listItem.Com:SetPosition(140,0);
	    	listItem.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem.Com:SetText(selectitem.Com:GetText());
	    	listItem.Img=Turbine.UI.Label();
	    	listItem.Img:SetParent(listItem);
	    	listItem.Img:SetSize(20,20);
	    	listItem.Img:SetPosition(0,0);
	    	listItem.Img:SetTop(1);
	    	listItem.Img:SetBackground(selectitem.Img:GetBackground());
		sender:InsertItem( sender:GetItemCount(), listItem );
	    	for i = 1, sender:GetItemCount() do
	    	  checkItem = sender:GetItem(i);
		  if checkItem.Img:GetBackground() == nil then
			sender:RemoveItemAt(i);
			sender:SetHeight( sender:GetHeight() - 20 );
	    	   	sender:GetParent():SetHeight(sender:GetParent():GetHeight() - ROW_HEIGHT - ROW_SPACING);
	    	  break;
		  end
	        end
	    end
	    presender:RemoveItemAt(preindex);
	    presender:SetHeight( presender:GetHeight() - 20 );
	    presender:GetParent():SetHeight(presender:GetParent():GetHeight() - ROW_HEIGHT - ROW_SPACING);
	    if sender:GetParent() ~= presender:GetParent() then
	 	  FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/unlock.tga");
		  FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND_r.tga");
	 	  FAMainlock.lock = false;
	    end

	    itemselect = false;
	    if senderID == 0 then
		Turbine.UI.Window.SetWidth(FAMainWindow,210);
	    else
		Turbine.UI.Window.SetWidth(FASubWindow[senderID],210);
	    end
	    LeftShiftWindows();

	    sender:SetSelectedIndex(0);
	else
	    selectitem = sender:GetSelectedItem();
	    if selectitem == nil then return end
	    selectitem:SetBackColor( Turbine.UI.Color( 22/256, 178/256, 170/256 ) );
	    sender:SetSelectedItem(selectitem);
	    presender = sender;
	    preindex = sender:GetSelectedIndex();
	    itemselect = true;

	    sendParent = sender:GetParent();
	    sendername = sendParent:GetText();
	    if sendername == "Master" then
	       senderID = 0;
	    else
		for k,v in pairs(FASubWindow) do
	       	   if v:GetText() == sendername then
		      senderID = k;
		   end
	    	end
	    end

	    if senderID == 0 then
		Turbine.UI.Window.SetWidth(FAMainWindow,420);
	    else
		Turbine.UI.Window.SetWidth(FASubWindow[senderID],420);
	    end
	    RightShiftWindows();
	    sender:SetSelectedIndex(0);
	end
end

listbox2Changed = function(sender, args)
	if sender:GetSelectedIndex() ~= 0 then
	if itemselect then
	    thisitem = sender:GetSelectedItem();
	    thisidx = sender:GetSelectedIndex();
	    FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/unlock.tga");
	    FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND_r.tga");
	    FAMainlock.lock = false;
	    if selectitem.Img:GetBackground() == nil then
	    	if thisitem.Img:GetBackground() ~= nil then
	           sender:RemoveItemAt(thisidx);
	    	   sender:SetHeight( sender:GetHeight() - 20 );
	    	   sender:GetParent():SetHeight(sender:GetParent():GetHeight() - ROW_HEIGHT - ROW_SPACING);
		end
	    else
		local listItem = Turbine.UI.Control();
            	listItem:SetSize( 370, 20 );
	    	listItem.Qty=Turbine.UI.Label();
	    	listItem.Qty:SetParent(listItem);
	    	listItem.Qty:SetSize(115,20);
	    	listItem.Qty:SetPosition(25,0);
	    	listItem.Qty:SetTop(1);
	    	listItem.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem.Qty:SetText(selectitem.Qty:GetText());
		listItem.Com = Turbine.UI.TextBox();
	    	listItem.Com:SetMultiline(false);
      	   	listItem.Com:SetParent( listItem );
     	    	listItem.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    	listItem.Com:SetSize( 230, 20 );
	    	listItem.Com:SetPosition(140,0);
	    	listItem.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem.Com:SetText(selectitem.Com:GetText());
	    	listItem.Img=Turbine.UI.Label();
	    	listItem.Img:SetParent(listItem);
	    	listItem.Img:SetSize(20,20);
	    	listItem.Img:SetPosition(0,0);
	    	listItem.Img:SetTop(1);
	    	listItem.Img:SetBackground(selectitem.Img:GetBackground());
            	sender:SetItem( thisidx, listItem );
	    end
	    if thisitem.Img:GetBackground() == nil then

	        presender:RemoveItemAt(preindex);
	    	presender:SetHeight( presender:GetHeight() - 20 );
	    	presender:GetParent():SetHeight(presender:GetParent():GetHeight() - ROW_HEIGHT - ROW_SPACING);
	    else
		local listItem2 = Turbine.UI.Control();
            	listItem2:SetSize( 370, 20 );
	    	listItem2.Qty=Turbine.UI.Label();
	    	listItem2.Qty:SetParent(listItem2);
	    	listItem2.Qty:SetSize(115,20);
	    	listItem2.Qty:SetPosition(25,0);
	    	listItem2.Qty:SetTop(1);
	    	listItem2.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem2.Qty:SetText(thisitem.Qty:GetText());
		listItem2.Com = Turbine.UI.TextBox();
	    	listItem2.Com:SetMultiline(false);
      	   	listItem2.Com:SetParent( listItem2 );
     	    	listItem2.Com:SetBackColor( Turbine.UI.Color( 0, 0, 1 ) );
      	    	listItem2.Com:SetSize( 230, 20 );
	    	listItem2.Com:SetPosition(140,0);
	    	listItem2.Com:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	listItem2.Com:SetText(thisitem.Com:GetText());
	    	listItem2.Img=Turbine.UI.Label();
	    	listItem2.Img:SetParent(listItem2);
	    	listItem2.Img:SetSize(20,20);
	    	listItem2.Img:SetPosition(0,0);
	    	listItem2.Img:SetTop(1);
	    	listItem2.Img:SetBackground(thisitem.Img:GetBackground());
	    	presender:SetItem(preindex, listItem2);
	    end

	    itemselect = false;
	    if senderID == 0 then
		Turbine.UI.Window.SetWidth(FAMainWindow,210);
	    else
		Turbine.UI.Window.SetWidth(FASubWindow[senderID],210);
	    end

	    LeftShiftWindows();

	    sender:SetSelectedIndex(0);
	else
	    selectitem = sender:GetSelectedItem();
	    if selectitem == nil then return end
	    selectitem:SetBackColor( Turbine.UI.Color( 22/256, 178/256, 170/256 ) );
	    sender:SetSelectedItem(selectitem);
	    presender = sender;
	    preindex = sender:GetSelectedIndex();
	    itemselect = true;

	    sendParent = sender:GetParent();
	    sendername = sendParent:GetText();
	    if sendername == "Master" then
	       senderID = 0;
	    else
		for k,v in pairs(FASubWindow) do
	       	   if v:GetText() == sendername then
		      senderID = k;
		   end
	    	end
	    end

	    if senderID == 0 then
		Turbine.UI.Window.SetWidth(FAMainWindow,420);
	    else
		Turbine.UI.Window.SetWidth(FASubWindow[senderID],420);
	    end
	    RightShiftWindows();

	    sender:SetSelectedIndex(0);
	end
	end
end

AddCallback(FAMainWindow.listbox, "SelectedIndexChanged", listbox2Changed);
AddCallback(FAMainWindow.listbox, "MouseDown", listbox2MouseDown);

------------------------------------------------------------------------------------

FASubWindow = {};
SquadID = 1;

function delSquad(sender, args)
	    sendParent = sender:GetParent();
	    if sendParent.listbox:GetItemCount() == 0 then
	       sendername = sendParent:GetText();
	       for k,v in pairs(FASubWindow) do
	       	   if v:GetText() == sendername then
		      removeID = k;
		   end
	       end
	       sendParent:SetVisible(false);
	       table.remove (FASubWindow ,removeID);
	       senderID = removeID -1;
	       LeftShiftWindows();
	    end

end

function AddSquad(sender, args)
	 SquadC = table.maxn(FASubWindow) + 1;
	 SquadID = SquadID +1;

	 FAMainlock:SetBackground("Sigman/FormationAssist2/Resources/unlock.tga");
	 FAMainbtn2:SetBackground("Sigman/FormationAssist2/Resources/SEND_r.tga");
	 FAMainlock.lock = false;

	 WinY = 30;

	 if SquadC == 1 then
	    	WinX = 350;
	 else
		WinX = FASubWindow[SquadC-1]:GetLeft() + 220;
		if WinX+420 > Turbine.UI.Display.GetWidth() then
		   WinX = WinX - 220;
		   WinY = FASubWindow[SquadC-1]:GetTop() + FASubWindow[SquadC-1]:GetHeight() + 10;
	 	end
	 end

	 FASubWindow[SquadC] = Turbine.UI.Window();
	 FASubWindow[SquadC]:SetPosition(WinX,WinY);
	 FASubWindow[SquadC]:SetSize(210, 150);
	 FASubWindow[SquadC]:SetText("Squad "..SquadID);
	 FASubWindow[SquadC]:SetVisible(true);
	 FASubWindow[SquadC]:SetMouseVisible(true);

	 FASubWindow[SquadC].squadname = Turbine.UI.Lotro.TextBox();
	 FASubWindow[SquadC].squadname:SetParent( FASubWindow[SquadC] );
	 FASubWindow[SquadC].squadname:SetBackColor( Turbine.UI.Color( 0, 0, 0.5 ) );
	 FASubWindow[SquadC].squadname:SetPosition( 10, 40 );
	 FASubWindow[SquadC].squadname:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	 FASubWindow[SquadC].squadname:SetText("Squad "..SquadC+1);
	 FASubWindow[SquadC].squadname:SetSize( 190, 20 );

	 FASubWindow[SquadC].button = Turbine.UI.Lotro.Button();
	 FASubWindow[SquadC].button:SetParent(FASubWindow[SquadC]);
	 FASubWindow[SquadC].button:SetSize(80,20);
	 FASubWindow[SquadC].button:SetPosition(30,70);
	 FASubWindow[SquadC].button:SetText("Remove");
	 FASubWindow[SquadC].button.MouseClick = delSquad;

      	 FASubWindow[SquadC].listbox = Turbine.UI.ListBox();
      	 FASubWindow[SquadC].listbox:SetParent( FASubWindow[SquadC] );
      	 FASubWindow[SquadC].listbox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
      	 FASubWindow[SquadC].listbox:SetPosition( 30, 100 );
      	 FASubWindow[SquadC].listbox:SetSize( 370, 20 );
      	 FASubWindow[SquadC].listbox:SetAllowDrop( true );
      	 FASubWindow[SquadC].listbox:SetMouseVisible(true);

	 AddCallback(FASubWindow[SquadC].listbox, "SelectedIndexChanged", listbox2Changed);
	 AddCallback(FASubWindow[SquadC].listbox, "MouseDown", listbox2MouseDown);

end

AddSquad();

FAMainbtn1 = Turbine.UI.Lotro.Button();
FAMainbtn1:SetParent(FAMainWindow);
FAMainbtn1:SetSize(80,20);
FAMainbtn1:SetPosition(30,70);
FAMainbtn1:SetText("Add Squad");
FAMainbtn1.MouseClick = AddSquad;

FAmain.VisibleChanged = function(sender, args)
	if FAmain:IsVisible() == false then
		FAMainWindow:SetVisible(false);
		for i = 1 , table.maxn(FASubWindow) do
 		    FASubWindow[i]:SetVisible(false);
		end
	end
end



------------------------------------------------------------------------------------

end


